/*
  ----------------------------------------------------------------------
  NOME: 
  CONGNOME: 
  MATRICOLA: 
  CODICE CALCOLATORE: 
  ----------------------------------------------------------------------
*/

#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;

const int N_PIANI = 2;
const int N_STANZE = 3;
const char* FNAME = "prenotazioni";


/* --------------------------- INIZIO PUNTO 1  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

/*********************************************************************** 
            !!!!!!!!!!!   A T T E N Z I O N E   !!!!!!!!!!! 
       Compilare con i propri dati l'intestazione del file *PRIMA* di
       cominciare! (e poi _cancellare_ questo testo)
************************************************************************/
    
/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 1  -------------------------- */



/* --------------------------- INIZIO PUNTO 2  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 2 -------------------------- */



/* --------------------------- INIZIO PUNTO 3  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 3 -------------------------- */



/* --------------------------- INIZIO PUNTO 4  ------------------------- */
/*                    Scrivere qui sotto la soluzione                    */
/*    vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv   */
bool Albergo_prenota_stanza(ListaPrenotazioni* alb[N_PIANI][N_STANZE], 
			    const Prenotazione& pren) 
{
  /* ... */

  return false;
}

/*    ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^   */
/* ---------------------------- FINE PUNTO 4 -------------------------- */



/* Inizializza l'albergo inserendo in tutte le stanze una lista di
   prenotazione vuota. */
void Albergo_init(ListaPrenotazioni* alb[N_PIANI][N_STANZE]) 
{
  for (int p=0; p < N_PIANI; ++p) {
    for (int s=0; s < N_STANZE; ++s) {
      alb[p][s] = NULL;
    }
  }
}


/* legge da file una singola prenotazione */
bool leggi_prenotazione(istream& is, Prenotazione &p)
{
  string str;
  is >> str; p.nome = strdup(str.c_str());
  if (is.fail()) return false;

  is >> str; p.cognome = strdup(str.c_str());
  if (is.fail()) return false;

  is >> p.data; 
  if (is.fail()) return false;

  is >> p.giorni;
  if (is.fail()) return false;

  return true;
}

/* carica da un file tutte le prenotazioni nell'albergo */
void Albergo_carica_prenotazioni(ListaPrenotazioni* alb[N_PIANI][N_STANZE])
{
  ifstream ifs(FNAME);
  while (!ifs.eof()) {
    Prenotazione p;
    if (!leggi_prenotazione(ifs, p)) return;
    
    if (! Albergo_prenota_stanza(alb, p)) {
      cout << "La prenotazione:\n   "; 
      Prenotazione_stampa(p);
      cout << endl << "non puo' essere soddisfatta.\n\n";
    }
  }
}


// ----------------------------------------------------------------------
// Main del programma
// ----------------------------------------------------------------------

int main() 
{
  ListaPrenotazioni* albergo[N_PIANI][N_STANZE];
  Albergo_init(albergo);
  Albergo_carica_prenotazioni(albergo);

  Albergo_stampa(albergo);

  return 0;
}
